<?php

    /*
     * Plugin Name: In8Sync Products
     * Description: This plugin manages product syncing with NetSuite
     * Version: 3.2.16
     * Author: In8Sync
     * Author URI: http://www.in8sync.com
     */
    if (!defined('ABSPATH')) {
        exit; // Exit if accessed directly
    }
// run the install scripts upon plugin activation
    register_activation_hook(__FILE__, 'installIn8ProductPlugin');

// function for creating log table "in8sync_log"
    function installIn8ProductPlugin() {
        //check if in8sync plugin is installed and activated
        if (!in_array('in8sync/in8sync.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            //deactivate plugin if parent in8sync is not activated
            deactivate_plugins(__FILE__);
            echo '<div id="error" class="error notice is-dismissible"><p>Plugin can\'t be activated.Please install main in8 plugin before activating.</div>';
            die;
        }
    }

//plugins load hook
    add_action('plugins_loaded', 'init_in8_products_plugin', 20);

    function init_in8_products_plugin() {

        //check if in8sync plugin is installed and activated
        if (in_array('in8sync/in8sync.php', apply_filters('active_plugins', get_option('active_plugins')))) {

            define('In8_Products_Plugin_URL', plugin_dir_url(__FILE__));
            define('In8_Products_Plugin_PATH', plugin_dir_path(__FILE__));

            require_once('inc/endpoints.php'); //load endpoints
	        require_once 'inc/api_classes/class_wc_api_product_translation.php';
	        
	        $disableSync = IN8_Settings::isSyncDisabled();
	        
	        //check if product plugin is enabled
            $enable_options = get_option('in8_product_plugin_enabled');
            if (isset($enable_options['is_enabled']) && $enable_options['is_enabled'] == 'on' && !$disableSync) { //check if admin have enabled product plugin
                define('PRODUCT_SYNC_ENABLED', 1); //set enabled variable for loading template
	
                require_once('inc/code/Map.php');
                require_once('inc/code/ProcessMap.php');
            }
            require_once('inc/options.php');
            require_once('inc/sync.php');
        } else {
            include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
            //deactivate plugin if parent in8sync is not activated
            deactivate_plugins(__FILE__);
        }
    }

//    add_action('admin_init', 'in8_activate_updates_products');

    function in8_activate_updates_products() {
        require_once (IN8_MAIN_DIR . '/code/in8-update.php');

        $plugin_data = get_plugin_data(__FILE__);
        if (isset($plugin_data['Version'])) {
            $plugin_current_version = $plugin_data['Version'];
        } else {
            $plugin_current_version = '2.0.1';
        }
        $plugin_remote_path = 'https://secure.in8sync.com/update/currentversion.php';
        $plugin_slug = plugin_basename(__FILE__);
        new in8_wp_auto_update($plugin_current_version, $plugin_remote_path, $plugin_slug);
    }
    