var in8_item_qty_based_pricing = {};
jQuery(function($){

    $(document).on('change', 'form.cart input.qty', in8_item_qty_based_pricing_handler)
    $(document).on('keyup', 'form.cart input.qty', in8_item_qty_based_pricing_handler)

    $(document).on('change', 'form.variations_form.cart input[name=variation_id]', function(){
        var $product = $(this).parents('.summary');
        $product.find('.in8-qty-based-pricing').hide();
        $('.in8-qty-pricing-message').hide();

        if( !$(this).val() ) return;

        $product.find('.in8-qty-based-pricing[data-product_id="'+$(this).val()+'"]').show();
        $('.in8-qty-pricing-message').show();
        $('form.cart input.qty').trigger('change');
    })

    $('form.cart input.qty').trigger('change');

    function in8_item_qty_based_pricing_handler(){
        var $form = $(this).parents('form');
        var productId = $form.find('.single_add_to_cart_button').val();
        var isVariation = false;
        if( !productId ) {
            isVariation = true;
            productId = $form.find('.variation_id').val();
        }
        if( !productId ) return;
        if( !in8_item_qty_based_pricing[productId] ) return;
        var prices = in8_item_qty_based_pricing[productId];

        var $price = $('.product .summary .price');
        if( isVariation ){
            $price = $('.product .summary .woocommerce-variation-price');
        }
        var qty = $(this).val();

        var price = 0;
        for(var key in prices){
            var priceRule = prices[key];
            if( parseInt(priceRule['from']) <= qty && (qty <= parseInt(priceRule['to']) || !priceRule['to']) ){
                price = priceRule['price_html'];
                break;
            }
        }

        if( price ){
            $price.html(price);
        }
    }
});