<?php
	/*
	 * Copy of the mapping used on importing products from ns
	 * */
	
	class IN8_Product_Map {
		
		public static $wpcustomfields = [
			'_custom,userInput' => 'Insert custom field name...',
			'_fixed,userInput' => 'Assign a fixed value...'
		
		];
		public static $wpFields = [
			'post,post_title' => 'Product Title',
			'post,post_content' => 'Product Content',
			'post,post_excerpt' => 'Product Excerpt',
			'post,post_name' => 'Product Url/Name',
			'post,post_date' => 'Product Date',
			'meta,_sku' => 'Product Sku',
			'meta,_regular_price' => 'Product Regular Price',
			'meta,_price' => 'Product Price',
			'meta,_crosssell_ids' => 'CrossSell Items',
		];
		public static $nscustomfields = [
			'_item,userInput' => 'Insert NetSuite field name...',
		];
		public static $nsFields = [
			'item,price' => 'Price',
			'item,sku' => 'Sku',
			'item,qty' => 'Qty',
			'item,category' => 'Category',
			'item,relatedItems' => 'Related Items',
			'item,createdDate' => 'createdDate',
			'item,lastModifiedDate' => 'lastModifiedDate',
			'item,purchaseDescription' => 'purchaseDescription',
			'item,copyDescription' => 'copyDescription',
			'item,expenseAccount' => 'expenseAccount',
			'item,dateConvertedToInv' => 'dateConvertedToInv',
			'item,originalItemType' => 'originalItemType',
			'item,originalItemSubtype' => 'originalItemSubtype',
			'item,cogsAccount' => 'cogsAccount',
			'item,salesDescription' => 'salesDescription',
			'item,includeChildren' => 'includeChildren',
			'item,incomeAccount' => 'incomeAccount',
			'item,taxSchedule' => 'taxSchedule',
			'item,dropshipExpenseAccount' => 'dropshipExpenseAccount',
			'item,isTaxable' => 'isTaxable',
			'item,matrixType' => 'matrixType',
			'item,assetAccount' => 'assetAccount',
			'item,matchBillToReceipt' => 'matchBillToReceipt',
			'item,billQtyVarianceAcct' => 'billQtyVarianceAcct',
			'item,billPriceVarianceAcct' => 'billPriceVarianceAcct',
			'item,billExchRateVarianceAcct' => 'billExchRateVarianceAcct',
			'item,gainLossAccount' => 'gainLossAccount',
			'item,shippingCost' => 'shippingCost',
			'item,shippingCostUnits' => 'shippingCostUnits',
			'item,handlingCost' => 'handlingCost',
			'item,handlingCostUnits' => 'handlingCostUnits',
			'item,weight' => 'weight',
			'item,weightUnit' => 'weightUnit',
			'item,weightUnits' => 'weightUnits',
			'item,costingMethodDisplay' => 'costingMethodDisplay',
			'item,unitsType' => 'unitsType',
			'item,stockUnit' => 'stockUnit',
			'item,purchaseUnit' => 'purchaseUnit',
			'item,saleUnit' => 'saleUnit',
			'item,issueProduct' => 'issueProduct',
			'item,billingSchedule' => 'billingSchedule',
			'item,trackLandedCost' => 'trackLandedCost',
			'item,isDropShipItem' => 'isDropShipItem',
			'item,isSpecialOrderItem' => 'isSpecialOrderItem',
			'item,stockDescription' => 'stockDescription',
			'item,deferredRevenueAccount' => 'deferredRevenueAccount',
			'item,producer' => 'producer',
			'item,manufacturer' => 'manufacturer',
			'item,revRecSchedule' => 'revRecSchedule',
			'item,mpn' => 'mpn',
			'item,multManufactureAddr' => 'multManufactureAddr',
			'item,manufacturerAddr1' => 'manufacturerAddr1',
			'item,manufacturerCity' => 'manufacturerCity',
			'item,manufacturerState' => 'manufacturerState',
			'item,manufacturerZip' => 'manufacturerZip',
			'item,countryOfManufacture' => 'countryOfManufacture',
			'item,roundUpAsComponent' => 'roundUpAsComponent',
			'item,defaultItemShipMethod' => 'defaultItemShipMethod',
			'item,itemCarrier' => 'itemCarrier',
			'item,itemShipMethodList' => 'itemShipMethodList',
			'item,manufacturerTaxId' => 'manufacturerTaxId',
			'item,scheduleBNumber' => 'scheduleBNumber',
			'item,scheduleBQuantity' => 'scheduleBQuantity',
			'item,scheduleBCode' => 'scheduleBCode',
			'item,manufacturerTariff' => 'manufacturerTariff',
			'item,preferenceCriterion' => 'preferenceCriterion',
			'item,minimumQuantity' => 'minimumQuantity',
			'item,enforceMinQtyInternally' => 'enforceMinQtyInternally',
			'item,minimumQuantityUnits' => 'minimumQuantityUnits',
			'item,softDescriptor' => 'softDescriptor',
			'item,shipPackage' => 'shipPackage',
			'item,shipIndividually' => 'shipIndividually',
			'item,costCategory' => 'costCategory',
			'item,pricesIncludeTax' => 'pricesIncludeTax',
			'item,purchasePriceVarianceAcct' => 'purchasePriceVarianceAcct',
			'item,quantityPricingSchedule' => 'quantityPricingSchedule',
			'item,reorderPointUnits' => 'reorderPointUnits',
			'item,useMarginalRates' => 'useMarginalRates',
			'item,preferredStockLevelUnits' => 'preferredStockLevelUnits',
			'item,costEstimateType' => 'costEstimateType',
			'item,costEstimate' => 'costEstimate',
			'item,transferPrice' => 'transferPrice',
			'item,overallQuantityPricingType' => 'overallQuantityPricingType',
			'item,pricingGroup' => 'pricingGroup',
			'item,vsoePrice' => 'vsoePrice',
			'item,vsoeSopGroup' => 'vsoeSopGroup',
			'item,costEstimateUnits' => 'costEstimateUnits',
			'item,vsoeDeferral' => 'vsoeDeferral',
			'item,vsoePermitDiscount' => 'vsoePermitDiscount',
			'item,vsoeDelivered' => 'vsoeDelivered',
			'item,preferredLocation' => 'preferredLocation',
			'item,reorderMultiple' => 'reorderMultiple',
			'item,cost' => 'cost',
			'item,lastInvtCountDate' => 'lastInvtCountDate',
			'item,nextInvtCountDate' => 'nextInvtCountDate',
			'item,invtCountInterval' => 'invtCountInterval',
			'item,invtClassification' => 'invtClassification',
			'item,costUnits' => 'costUnits',
			'item,totalValue' => 'totalValue',
			'item,averageCost' => 'averageCost',
			'item,useBins' => 'useBins',
			'item,quantityReorderUnits' => 'quantityReorderUnits',
			'item,leadTime' => 'leadTime',
			'item,autoLeadTime' => 'autoLeadTime',
			'item,lastPurchasePrice' => 'lastPurchasePrice',
			'item,autoPreferredStockLevel' => 'autoPreferredStockLevel',
			'item,preferredStockLevelDays' => 'preferredStockLevelDays',
			'item,safetyStockLevel' => 'safetyStockLevel',
			'item,safetyStockLevelDays' => 'safetyStockLevelDays',
			'item,backwardConsumptionDays' => 'backwardConsumptionDays',
			'item,seasonalDemand' => 'seasonalDemand',
			'item,safetyStockLevelUnits' => 'safetyStockLevelUnits',
			'item,demandModifier' => 'demandModifier',
			'item,autoReorderPoint' => 'autoReorderPoint',
			'item,storeDisplayName' => 'storeDisplayName',
			'item,storeDisplayThumbnail' => 'storeDisplayThumbnail',
			'item,storeDisplayImage' => 'storeDisplayImage',
			'item,storeDescription' => 'storeDescription',
			'item,storeDetailedDescription' => 'storeDetailedDescription',
			'item,storeItemTemplate' => 'storeItemTemplate',
			'item,pageTitle' => 'pageTitle',
			'item,metaTagHtml' => 'metaTagHtml',
			'item,excludeFromSitemap' => 'excludeFromSitemap',
			'item,sitemapPriority' => 'sitemapPriority',
			'item,searchKeywords' => 'searchKeywords',
			'item,isDonationItem' => 'isDonationItem',
			'item,showDefaultDonationAmount' => 'showDefaultDonationAmount',
			'item,maxDonationAmount' => 'maxDonationAmount',
			'item,dontShowPrice' => 'dontShowPrice',
			'item,noPriceMessage' => 'noPriceMessage',
			'item,outOfStockMessage' => 'outOfStockMessage',
			'item,onSpecial' => 'onSpecial',
			'item,outOfStockBehavior' => 'outOfStockBehavior',
			'item,relatedItemsDescription' => 'relatedItemsDescription',
			'item,specialsDescription' => 'specialsDescription',
			'item,featuredDescription' => 'featuredDescription',
			'item,shoppingDotComCategory' => 'shoppingDotComCategory',
			'item,shopzillaCategoryId' => 'shopzillaCategoryId',
			'item,nexTagCategory' => 'nexTagCategory',
			'item,urlComponent' => 'urlComponent',
			'item,customForm' => 'customForm',
			'item,itemId' => 'itemId',
			'item,upcCode' => 'upcCode',
			'item,displayname' => 'displayName',
			'item,vendorName' => 'vendorName',
			'item,parent' => 'parent',
			'item,isOnline' => 'isOnline',
			'item,isHazmatItem' => 'isHazmatItem',
			'item,hazmatId' => 'hazmatId',
			'item,hazmatShippingName' => 'hazmatShippingName',
			'item,hazmatHazardClass' => 'hazmatHazardClass',
			'item,hazmatPackingGroup' => 'hazmatPackingGroup',
			'item,hazmatItemUnits' => 'hazmatItemUnits',
			'item,hazmatItemUnitsQty' => 'hazmatItemUnitsQty',
			'item,isGcoCompliant' => 'isGcoCompliant',
			'item,offerSupport' => 'offerSupport',
			'item,isInactive' => 'isInactive',
			'item,availableToPartners' => 'availableToPartners',
			'item,department' => 'department',
			'item,class' => 'class',
			'item,location' => 'location',
			'item,costingMethod' => 'costingMethod',
			'item,currency' => 'currency',
			'item,preferredStockLevel' => 'preferredStockLevel',
			'item,pricingMatrix' => 'pricingMatrix',
			'item,accountingBookDetailList' => 'accountingBookDetailList',
			'item,purchaseTaxCode' => 'purchaseTaxCode',
			'item,defaultReturnCost' => 'defaultReturnCost',
			'item,supplyReplenishmentMethod' => 'supplyReplenishmentMethod',
			'item,alternateDemandSourceItem' => 'alternateDemandSourceItem',
			'item,fixedLotSize' => 'fixedLotSize',
			'item,periodicLotSizeType' => 'periodicLotSizeType',
			'item,supplyType' => 'supplyType',
			'item,demandTimeFence' => 'demandTimeFence',
			'item,supplyTimeFence' => 'supplyTimeFence',
			'item,rescheduleInDays' => 'rescheduleInDays',
			'item,rescheduleOutDays' => 'rescheduleOutDays',
			'item,periodicLotSizeDays' => 'periodicLotSizeDays',
			'item,supplyLotSizingMethod' => 'supplyLotSizingMethod',
			'item,forwardConsumptionDays' => 'forwardConsumptionDays',
			'item,demandSource' => 'demandSource',
			'item,quantityBackOrdered' => 'quantityBackOrdered',
			'item,quantityCommitted' => 'quantityCommitted',
			'item,quantityAvailable' => 'quantityAvailable',
			'item,quantityOnHand' => 'quantityOnHand',
			'item,onHandValueMli' => 'onHandValueMli',
			'item,quantityOnOrder' => 'quantityOnOrder',
			'item,rate' => 'rate',
			'item,reorderPoint' => 'reorderPoint',
			'item,quantityCommittedUnits' => 'quantityCommittedUnits',
			'item,salesTaxCode' => 'salesTaxCode',
			'item,quantityAvailableUnits' => 'quantityAvailableUnits',
			'item,quantityOnHandUnits' => 'quantityOnHandUnits',
			'item,vendor' => 'vendor',
			'item,quantityOnOrderUnits' => 'quantityOnOrderUnits',
			'item,productFeedList' => 'productFeedList',
			'item,subsidiaryList' => 'subsidiaryList',
			'item,itemOptionsList' => 'itemOptionsList',
			'item,itemVendorList' => 'itemVendorList',
			'item,siteCategoryList' => 'siteCategoryList',
			'item,translationsList' => 'translationsList',
			'item,binNumberList' => 'binNumberList',
			'item,locationsList' => 'locationsList',
			'item,matrixOptionList' => 'matrixOptionList',
			'item,presentationItemList' => 'presentationItemList',
			'item,customFieldList' => 'customFieldList',
			'item,internalId' => 'internalId',
			'item,externalId' => 'externalId',
			'item,nullFieldList' => 'nullFieldList',
		];
		public static $mapTag = 'in8_netsuite_wc_to_ns_map';
		
		public static function getMap($default = []) {
			$options = get_option(self::$mapTag, $default);
			
			if (!is_array($options)) {
				$options = [];
			}
			
			return $options;
		}
		
		public static function updateMap($options, $overwriteOld = TRUE) {
			$oldOptions = self::getMap([]);
			$options = ( $overwriteOld ? array_merge($oldOptions, $options) : $oldOptions + $options );
			update_option(self::$mapTag, $options);
			return $options;
		}
		
		public static function setMap($options) {
			update_option(self::$mapTag, $options);
			return $options;
		}
		
		public static function getFinalMap() {
			$option = self::getMap();
			
			$_option = [];
			foreach ($option['wp_selector'] as $key => $val) {
				$wp = $option['wp_selector'][$key];
				$ns = $option['ns_selector'][$key];
				
				// this will turn the user input into meta
				$wp = str_replace(['_custom,userInput','_fixed,userInput'], ['meta',"fixed"], $wp);
				
				// this will turn the user input into field
				$ns = str_replace('_item,userInput,', '', $ns);
				$ns = str_replace('item,', '', $ns);
				
				$_option[$wp] = $ns;
			}
			
			
			return $_option;
		}
		
		// from here on we do the ajax and fields part
		
		function __construct() {
			
			// append to map fields
			
			
			add_action('wp_ajax_in8_wc_to_nc_mapping/line', [ 'IN8_Product_Map', 'line']);
			
			add_action('wp_ajax_in8_wc_to_nc_mapping/selector', [ 'IN8_Product_Map', 'field_selector']);
			
			add_action('wp_ajax_in8_wc_to_nc_mapping/selector_text', [ 'IN8_Product_Map', 'field_selector_text']);
			
			
			add_action('wp_ajax_in8_wc_to_nc_mapping/save', [ 'IN8_Product_Map', 'save_map']);
		}
		
		public static function line($values = '') {
			
			$ajax = isset($_REQUEST['action']);
			
			// to not mess with next calls
			
			self::resetAction();
			
			
			if ($ajax) {
				
				$values = [ 'wp_selector' => '', 'ns_selector' => '',];
			}
			
			
			$return = '<div class="line">';
			
			$return .= self::field_selector('wp', 'wp_selector[]', $values['wp_selector'], 'class=" form-control wp_selector"');
			
			$return .= self::field_selector('ns', 'ns_selector[]', $values['ns_selector'], 'class="form-control ns_selector"');
			
			$return .= self::remove_button();
			
			$return .= '</div>';
			
			
			if ($ajax) {
				
				echo json_encode([
					
					'type' => 'success',
					'html' => $return,
				]);
			} else {
				
				return $return;
			}
			
			exit;
		}
		
		public static function field_selector($type = '', $name = '', $value = '', $extra = '') {
			
			$ajax = isset($_REQUEST['action']);
			
			
			$type = ( $ajax ? $_REQUEST['type'] : $type );
			
			$name = ( $ajax ? $_REQUEST['name'] : $name );
			
			$value = ( $ajax ? $_REQUEST['value'] : $value );
			
			$isCustom = false;
			
			if (preg_match('/_custom,userInput,/i', $value)) {
				$isCustom = true;
				$inputValue = str_replace('_custom,userInput,', '', $value);
				$value = '_custom,userInput';
			}
			
			if (preg_match('/_fixed,userInput,/i', $value)) {
				$isCustom = true;
				$inputValue = str_replace('_fixed,userInput,', '', $value);
				$value = '_fixed,userInput';
			}
			
			if (preg_match('/_item,userInput,/i', $value)) {
				$isCustom = true;
				$inputValue = str_replace('_item,userInput,', '', $value);
				$value = '_item,userInput';
			}
			
			$extra = ( $ajax ? $_REQUEST['extra'] : $extra );
			
			
			ob_start();
			
			if ($type == 'wp') {
				asort(self::$wpFields);
				$fields = self::$wpcustomfields + self::$wpFields;
				
			} else {
				asort(self::$nsFields);
				$fields = self::$nscustomfields + self::$nsFields;
			}
			?>

			<div class="field">

				<select name="<?= $name ?>" <?= $extra ?>>
					<option value="0">Select a <?php echo ($type == 'wp')?"WooCommerce":"NetSuite";?> field</option>
					<?php foreach ($fields as $field => $title) { ?>

						<option value="<?= $field ?>" <?= ( $value == $field ? 'selected' : '' ) ?>><?= $title ?></option>
					
					<?php } ?>

				</select>
				<?php if ($isCustom) { ?>
					<input type="text" value="<?= $inputValue ?>" class="user_insert_text">
				<?php } ?>

			</div>
			
			<?php
			$return = ob_get_clean();
			
			
			if ($ajax) {
				
				echo json_encode([
					
					'type' => 'success',
					'html' => $return,
				]);
			} else {
				
				return $return;
			}
			
			exit;
		}
		
		public static function remove_button() {
			
			$ajax = isset($_REQUEST['action']);
			
			
			$return = '<a style="margin-top: 7px;" href="" class="line_remove btn btn-danger">X</a>';
			
			
			if ($ajax) {
				
				echo json_encode([
					
					'type' => 'success',
					'html' => $return,
				]);
			} else {
				
				return $return;
			}
		}
		
		public static function save_map() {
			
			$options = [];
			$options['wp_selector'] = $_REQUEST['wp_selector'];
			
			$options['ns_selector'] = $_REQUEST['ns_selector'];
			
			
			self::setMap($options);
			
			
			echo json_encode([
				
				'type' => 'success',
			]);
			
			
			exit;
		}
		
		public static function resetAction() {
			
			$_REQUEST['action'] = NULL;
		}
		
	}
	
	$IN8_Product_Map = new IN8_Product_Map();
    