<script src="<?php echo In8_Products_Plugin_URL . "inc/assets/js/map.js"; ?>"></script>
<div id="in8_page_<?= ProductSync::getOptionsTag() ?>" class="in8_page">
    <?php $enable_options = get_option('in8_product_plugin_enabled'); ?>
    <div class="row" style="margin-top: 10px;">
        <form class="in8_ajax_form_save col-xs-7" id="product_plugin_enable_form" role="form">
            <div class="form-group">
                <label for="enable_in8_product_plugin">Enable/Disable In8 Product Sync</label>
                <span class="woocommerce-help-tip" data-tip="This Will enable/disable In8 product plugin"></span>
                <input class="form-control" type="checkbox" <?php echo isset($enable_options['is_enabled']) ? 'checked' : '' ?> name="options[is_enabled]" id="enable_in8_product_plugin">
            </div>
            <input type="hidden" name="action" value="in8_product_plugin_enabled">
        </form>
    </div>

    <?php if (defined('PRODUCT_SYNC_ENABLED')) { ?>

        <div class="row">
            <hr/>
            <a style="display:none" class="in8SyncAjaxButton btn btn-warning pull-right" href="?importAllProducts=1">
                Add/Update all Products
            </a>
            <div class="well col-xs-4">
                <h3>Configurable options</h3>
                <form action="" class="in8_ajax_form_save" role="form">
                    <?php
                    $options = ProductSync::options();
                    if (!isset($options['categories']) || empty($options['categories'])) {
                        $options['categories'] = '';
                    }
                    ?>
                    <div class="form-group">
                        <label for="<?php echo ProductSync::getOptionsTag(); ?>_categories">Select category to Sync</label>
                        <span class="woocommerce-help-tip" data-tip="Only products from selected category will be synced, leave empty for all"></span>

                        <?php
                        wp_dropdown_categories([
                            'hierarchical' => 1,
                            'name' => 'options[categories]',
                            'id' => 'wir-price-edit-category',
                            'value_field' => 'term_id',
                            'taxonomy' => 'product_cat',
                            'show_option_none' => '---',
                            'selected' => $options['categories'],
                        ]);
                        ?>
                    </div>
                    <input type="hidden" name="action" value="<?= ProductSync::getOptionsTag() ?>">
                    <button class=" btn btn-success btn-lg">Save</button>
                </form>
            </div>
            <div class="well col-xs-9">
                <?php require_once('tabs/mapping.php'); ?>
            </div>

        </div>
    <?php } ?>
    <script>
        (function ($) {
            $(document).on('click', '#enable_in8_product_plugin', function (e) {
                if ($(this).is(":checked")) {
                    if (!confirm("Enabling this feature may alter your NetSuite product configuration. Do you wish to proceed?")) {
                        e.preventDefault();
                        return;
                    }
                }
                showLoading('...');
                var data = $("#product_plugin_enable_form").serialize();
                $.ajax({
                    type: "post",
                    dataType: "json",
                    url: ajaxurl,
                    data: data,
                    success: function (response) {
                        hideLoading();
                        if (response.type == "success") {
                            location.reload();
                        } else {
                            alert("Something went wrong");
                        }
                    }
                });
                return false;
            });
        })(jQuery);
    </script>
</div>
